package com.imari.boonobo.logic;

/**
 * @author Mar Llambí
 *	PFG - Event Recommender System
 *	Last updated: 18/01/2016
 */

public class MainClass {
	
	//this method verify if the entry params by console are correct
	private static boolean verifyMode(int mode){
		 try {
		      if (mode == 0  || mode == 1){
		    	  return true;
		      }else{ 
		    	  return false;
		      }
		 }catch (Exception e) {
		      e.printStackTrace();
		      return false;
		 }
	}
	
	//print help method
	public static void printHelp(){
		System.out.println("*** THIS IS A RECOMMENDER SYSTEM ***");
		System.out.println("Execute jar adding one input mode:");
		System.out.println("0 - For everyone neighbood");
		System.out.println("1 - For only friend-users neighbood");
	}
	

	public static void main(String [ ] args){
		
       try{
    	   
    	   if (args.length == 1){
    		   if (args[0].equals("-h")){
    			   printHelp();
    		   }else{   
	    		   int mode = Integer.parseInt(args[0]);
	    		   if (verifyMode(mode)){
	    			   long startTime = System.currentTimeMillis();
	    			   
	    			   RSystem d = new RSystem();
	    			   d.setMode(mode);
	            	   d.retrieveData();
	            	   d.getPrediction();
	            	   
	            	   //evaluate execution time
	            	   long endTime   = System.currentTimeMillis();
	            	   long totalTime = endTime - startTime;
	            	   System.out.println("Total running time "+totalTime/1000+" seconds");
	    		   }else{
	    			   System.out.println("Please check your input arguments are correct '-h' input for help");
	    		   }   
    		   }
        	   
    	   }else{
    		   System.out.println("Invalid inputs");
    		   printHelp();
    	   }
    	   
    	  
    	   
       }catch (Exception e){
    	   System.out.println(e.getMessage());
    	   e.getStackTrace();
       }

	}
}
