<?php
// use Facebook\FacebookRequest;
App::uses('AppController', 'Controller');
App::uses('CakeEmail', 'Network/Email');

/**
 * Chat Controller
 *
 * @property Chat $Chat
 * @property PaginatorComponent $Paginator
 */
class ChatController extends AppController {

/**
 * Components
 *
 * @var array
 */
	public $components = array('Paginator');
    public $uses = array('User');
	
	
	function beforeFilter() {
		parent::beforeFilter();
		
		$this->__securityConf();
	}
	
	
	
	/**************** SECURITY FUNCTIONS ****************/
	
	private function __securityConf(){
		
		$this->Security->unlockedActions = array('converse','getUserConverse','sendMessage','newMessage','newMessageFromSomeone','newMessageFromOther','refreshList','loadEarlierMessages');
		
	}
	
	/************** END SECURITY FUNCTIONS **************/
	
	
	
	public function converse($idreciever = null){
		$idreciever = $this->request->data["idusuari"];
		$user_reciever = $this->Chat->User->find('first',array('conditions' => array('id' => $idreciever)));
		$this->set('user_reciever', $user_reciever);
		
		$current_user = $this->Auth->user();
		$this->Chat->Behaviors->attach('Containable');
		
		
		if(! $chat = $this->Chat->find('first',array('conditions' => array('reciever_user_id' => $idreciever,'user_id' =>  $current_user['id']),'contain'=> array('Message')))){
			$chat = $this->Chat->find('first',array('conditions' => array('reciever_user_id' => $current_user['id'],'user_id' =>  $idreciever),'contain'=> array('Message')));
		}
		
        $this->set('chat',$chat);
		$this->set('reciever',$idreciever);
		$this->set('current_user',$current_user);
		
		$messages = null;
		if (!empty($chat)) {
			//Posem els missatges que no estaven llegits, a llegits
			$messages = $this->Chat->Message->find('all',array('conditions' => array('chat_id' =>$chat['Chat']['id'],'user_send' =>  $idreciever,'message_read' => 0)));
			foreach($messages as $message){
				$this->Chat->Message->id = $message['Message']['id'];
				$this->Chat->Message->saveField('message_read',1);
			}
		}
		
		$this->set('messages',$messages);
		$this->set('reciever',$idreciever);
		
		$this->render("/Elements/chat",false);
	}
	
	
	public function getUserConverse($idreciever = null){
	    $this->autoRender = false;
	    
	    $idreciever = $this->request->data["idusuari"];
	    $user_reciever = $this->Chat->User->find('first',array('conditions' => array('id' => $idreciever)));
	    
	    $json_object = array();
	    $json_object['name'] = $user_reciever['User']['name'] . ' ' . $user_reciever['User']['surname'];
	    $json_object['photo_dir'] = $user_reciever['User']['photo_dir'];
	    $json_object['photo'] = $user_reciever['User']['photo'];
	    
	    echo json_encode($json_object);
	}
	
	
	public function loadEarlierMessages(){
	    $current_user = $this->Auth->user();
	    
	    $idreciever = $this->request->data["idusuari"];
		$index = $this->request->data["index"];
		$this->set('user_reciever',$this->Chat->User->find('first',array('conditions' => array('id' => $idreciever))));
		
		$this->Chat->Behaviors->attach('Containable');
		if(! $chat = $this->Chat->find('first',array('conditions' => array('reciever_user_id' => $idreciever,'user_id' =>  $current_user['id']),'contain'=> array('Message')))){
			$chat = $this->Chat->find('first',array('conditions' => array('reciever_user_id' => $current_user['id'],'user_id' =>  $idreciever),'contain'=> array('Message')));
		}
		
	    $this->set('chat',$chat);
		$this->set('reciever',$idreciever);
		$this->set('index',$index);
		$this->set('current_user',$current_user);
		
        $messages = null;		
		if (!empty($chat)) {
			//Posem els missatges que no estaven llegits, a llegits
			$messages = $this->Chat->Message->find('all',array('conditions' => array('chat_id' =>$chat['Chat']['id'],'user_send' =>  $idreciever,'message_read' => 0)));
			foreach($messages as $message){
				$this->Chat->Message->id=$message['Message']['id'];
				$this->Chat->Message->saveField('message_read',1);
			}
		}
		
		$this->set('messages',$messages);
		$this->set('reciever',$idreciever);
		
		$this->render("/Elements/chat_earlier_messages",false);
	}
	
	
	public function newMessage($chat_id= null){
	    $current_user = $this->Auth->user();
	    
		$idreciever = $this->request->data["idusuari"];
		$chat_id = $this->request->data["chat_id"];
		
		if($chat_id == 0){
			$chat = $this->Chat->find('first',array('conditions' => array('OR' => array(array('AND' => array("user_id" => $current_user['id'],"reciever_user_id" => $idreciever)),array('AND' => array("user_id" => $idreciever,"reciever_user_id" => $current_user['id']))))));
			if(!empty($chat)){
				$chat_id = $chat['Chat']['id'];
			}
		}
		if($chat_id != 0){
			$this->set('user_reciever',$this->Chat->User->find('first',array('conditions' => array('id' => $idreciever))));
	
			$messages = $this->Chat->Message->find('all',array('conditions' => array('chat_id' => $chat_id,'user_send' =>  $idreciever,'message_read' => 0)));
	
			foreach($messages as $message){
				$this->Chat->Message->id=$message['Message']['id'];
				$this->Chat->Message->saveField('message_read',1);
			}
			$this->set('messages',$messages);
			$this->set('reciever',$idreciever);

		}	
		
		$this->render("/Elements/new_messages",false);
		
	}
	
	
public function sendMessage($idchat = null){
		$this->autoRender = false;
	
		$senderid = $this->request->data["sender_id"];
		$message = $this->request->data["message"];
		$id_user_rec = $this->request->data["id_user_rec"];
		
		if (!empty($this->request->data["id"])){
			$idchat = $this->request->data["id"];
		}
		else {
			$chat = $this->Chat->find('first',array('conditions' => array('OR' => array(array('AND' => array("user_id" => $senderid,"reciever_user_id" => $id_user_rec)),array('AND' => array("user_id" => $id_user_rec,"reciever_user_id" => $senderid))))));
			if(empty($chat)){
					$this->Chat->create();
					$object = array("user_id" => $senderid,"reciever_user_id" => $id_user_rec);
					$this->Chat->save($object);
					$idchat=$this->Chat->id;
				}
				else{
					$idchat=$chat["Chat"]["id"];
				}
		}
		
		$this->Chat->Message->create();
		$object = array("chat_id"=>$idchat,"user_send" => $senderid,"message" => $message);
		$this->Chat->Message->save($object);
		
		$message_bd = $this->Chat->Message->findById($this->Chat->Message->id);
		
		$this->set('message',$message_bd['Message']);
		$this->set('reciever',2);

		//Li enviarem una notificació
		/*if (!$this->request->data["is_user_online"]){
			$this->sendNewMail($senderid,$message,$id_user_rec );
		}*/ 
		
		$this->render("/Elements/message",false);
	}
	private function sendNewMail($senderid, $message, $id_user_rec){
        $user_sender = $this->User->findById($senderid);
        $user_recipient = $this->User->findById($id_user_rec);

		$Email = new CakeEmail('smtp');

		$Email->to($user_recipient['User']['username'])
			->emailFormat('both')
			->subject(__('Nou missatge al xat'));

        $message = "Has rebut el seg�ent missatge de <b>".$user_sender['User']['name']. " ".$user_sender['User']['surname']."</b> mentre estaves offline:".$message;

		$Email->send($message);
	}
	public function newMessageFromSomeone(){
		$this->autoRender = false;
		$user = $this->Auth->user();

		if($chat = $this->Chat->find('list',array('conditions' => array("OR"=> array('user_id' =>  $user['id'],'reciever_user_id' => $user['id']))))){
    	    $newmessages = $this->Chat->Message->find('all',array('conditions' => array('chat_id' => array_keys($chat),'user_send <>' => $user['id'],'message_read' => 0)));
    	    $this->set('new_messages',$newmessages);
		}
		
		$this->render("/Elements/notification",false);
	}
	
	public function newMessageFromOther(){
		$idConverseUser = $this->request->data["idusuari"];
		$this->autoRender = false;
		$user = $this->Auth->user();
	
		if($chat = $this->Chat->find('list',array('conditions' => array("OR"=> array('user_id' =>  $user['id'],'reciever_user_id' => $user['id']))))){
			$converse_users = array();
			$converse_users[$user['id']] = $user['id'];
			$converse_users[$idConverseUser] = $idConverseUser;
			
			$newmessages = $this->Chat->Message->find('all',array('conditions' =>array('chat_id' => array_keys($chat),'user_send <>' => array_keys($converse_users), 'message_read' => 0)));
			$this->set('new_messages',$newmessages);
		}
	
		$this->render("/Elements/notification",false);
	}
	
	
	public function refreshList(){
		$this->autoRender = false;
		$current_user = $this->Auth->user();
		$chat_users = $this->Chat->searchFriends($current_user['id']);
		$this->set('chat_users', $chat_users);
		
		if($chat = $this->Chat->find('list',array('conditions' => array("OR"=> array('user_id' =>  $current_user['id'],'reciever_user_id' => $current_user['id']))))){
			$converse_users = $this->Chat->find('list',array('conditions' => array("AND"=> array('user_id' =>  $current_user['id'],'reciever_user_id' => $current_user['id']))));
		    $newmessages = $this->Chat->Message->find('all',array('conditions' => array('chat_id' => array_keys($chat),'user_send <>' => $current_user['id'],'message_read' => 0)));
		    $this->set('new_messages',$newmessages);
		}
		
		$this->render("/Elements/chatUsers",false);
	}
	

	
}	