<?php
App::uses('Component', 'Controller');
App::uses('Controller', 'Controller');

class LogUtilComponent extends Component {
    const LOG_TYPE_INFO = 0;
    const LOG_TYPE_WARRING = 1;
    const LOG_TYPE_ERROR = 2;    
    
    var $components = array('Auth');        
    /**
     * The name of the model that represents log datasource.  Defaults to 'User'.
     *
     * @var string
     * @access public
     */
    var $logModel = 'Log';
        
    /**
     * Parameter data from Auth::$user
     *
     * @var array
     * @access public
     */
    var $user = array();
    
    
    
    
    function initialize(Controller $controller){
        
    }
    
    function beforeRender(Controller $controller){
        
    }
    
    function shutdown(Controller $controller){
        
    }
    
    /**
     * Parameter data from Controller::$params
     *
     * @var array
     * @access public
     */
    var $params = array();
    
    function startup(Controller $controller){        
        $this->params = $controller->params;
        //if(isset($this->Auth)){
            $this->user = $this->Auth->user('id');
        //}
        
    }
    
    /**
     * get parameters from <code>$this->params['pass']</code>
     *
     * @return string, parameter which pass from url.
     */
    function __getParameters(){
        $parameters = '';
        
        if(!empty($this->params->query)){
            $parameters = 'GET ';
            foreach($this->params->query as $name => $value){
                if($name == 'password') continue;
                $parameters .= $name.'='.$value.'/';
            }
        }
        
        if(!empty($this->params->params['named'])){
            $parameters .= '/NAMED ';
            foreach($this->params->params['named'] as $name => $value){
                if($name == 'password') continue;
                $parameters .= $name.'='.$value.'/';
            }
        }
        
        if(!empty($this->params->data)){
            //$parameters .= '/DATA ';
            foreach($this->params->data as $name => $value){
                if($name == 'password') continue;
                if(is_array($value)){
                    $parameters .= $this->arrayRecursive($value);
                }
                else{
                    $parameters .= $name.'='.$value.'/';
                }
            }
        }
        /*if (!empty($this->params['pass'])){
            foreach ($this->params['pass'] as $param){
                $parameters .= $param.'/';
            }
        }*/
        return $parameters;
    }
    
    
    function hidePassword(){
        
    }
    
    
    function arrayRecursive($array){
        $params = '';
        foreach($array as $name => $value){
            if(is_array($value)){
                $params .= $name.'(';
                $params .= $this->arrayRecursive($value);
                $params .= ')/';
            }
            else{
                if($name == 'password') continue;
                $params .= $name.'='.$value.'/';
            }
        }
        
        return $params;
    }
    
    
    /**
     * Add one log to the log table.
     * parameters in <code>$options</code> can be:
     * <ul>
     *         <li>description: the value of this key insert instedof description field</li>
     *         <li>type: Determine type of log which could be info ,warring or error.They show by one number</li>
     *         <li>params: The value of this key insert instedof params field.By default it's user parameters</li>
     * </ul>
     *
     * @param array $options.
     * @param string $action
     * @param string $controller
     */
    function log($options=array(),$action=null,$controller=null){
        $params = $this->__getParameters();
        $action = (!empty($action)) ? $action :  $this->params['action'];
        $controller = (!empty($controller)) ? $controller :  $this->params['controller'];
        
        $options = array_merge(array('description'=>'','type'=>LogUtilComponent::LOG_TYPE_INFO,'params'=>$params),$options);
        
        $data['Log']['user_ip'] = $_SERVER['REMOTE_ADDR'];
        if(isset($_SERVER['HTTP_USER_AGENT'])){
            $data['Log']['user_browser'] = $_SERVER['HTTP_USER_AGENT'];
        }
        $data['Log']['controller'] = $controller;        
        $data['Log']['action'] = $action;        
        $data['Log']['params'] = $options['params'];        
        $data['Log']['description'] = $options['description'];                
        $data['Log']['type'] = $options['type'];
        $data['Log']['url'] = $this->params->url;
        $data['Log']['user_id'] = (!empty($this->user) ? $this->user : null);
        
        if($controller != 'chat' && $controller != 'files' && $action != 'newMessageFromSomeone' && $action != 'checkNewMessages'){
            $logModel = & $this->__getModel();
            $logModel->create();
            $logModel->save($data);
        }
    }
    
    /**
     * Returns a reference to the model object specified, and attempts
     * to load it if it is not found.
     *
     * @param string $name Model name (defaults to LogUtilComponent::$logModel)
     * @return object A reference to a model object
     * @access public
     */
    private function &__getModel($name = null) {
        $model = null;
        if (!$name) {
            $name = $this->logModel;
        }

        $model = ClassRegistry::init($name);

        if (empty($model)) {
            trigger_error(__('Log::getModel() - Model is not set or could not be found', true), E_USER_WARNING);
            return null;
        }

        return $model;
    }    
}
?>