<?php
App::uses('AppModel', 'Model');
/**
 * Event Model
 *
 * @property City $City
 * @property Category $Category
 */
class Event extends AppModel {

/**
 * Display field
 *
 * @var string
 */
	public $displayField = 'title';
	public $actsAs = array('Containable');

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'id' => array(
			'numeric' => array(
				'rule' => array('numeric'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'start_time' => array(
			'datetime' => array(
				'rule' => array('datetime'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'end_time' => array(
			'datetime' => array(
				'rule' => array('datetime'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'created' => array(
			'datetime' => array(
				'rule' => array('datetime'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'modified' => array(
			'datetime' => array(
				'rule' => array('datetime'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
		'active' => array(
			'numeric' => array(
				'rule' => array('numeric'),
				//'message' => 'Your custom message here',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
	);

	//The Associations below have been created with all possible keys, those that are not needed can be removed

/**
 * belongsTo associations
 *
 * @var array
 */
	public $belongsTo = array(
		'City' => array(
			'className' => 'City',
			'foreignKey' => 'city_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		),
		'Category' => array(
			'className' => 'Category',
			'foreignKey' => 'category_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		)
	);
	
	public $hasMany = array(
			'UserEvent' => array(
					'className' => 'UserEvent',
					'foreignKey' => 'event_id',
					'conditions' => '',
					'order' => 'UserEvent.created DESC',
					'limit' => '',
					'dependent' => true
			),
			'EventsComment' => array(
					'className' => 'EventsComment',
					'foreignKey' => 'event_id',
					'conditions' => '',
					'order' => 'EventsComment.created DESC',
					'limit' => '',
					'dependent' => true
			)
	);
	
	
	public function findEventAttributes ($id){
		if ($id != null){
			$event = 
			$this->find('all', array(
					'conditions' => array ('Event.id' => $id),
					'contain' => array (
							'City', 'Category'
							)));
		}
		return $event;
	}
	
	public function findEventsCategoryTime($filter_time, $filter_category, $offset, $elementsPerPage){
		
		return $this->find('all', array (
				'conditions' => array($filter_category,$filter_time),
				'contain' => array ('City'),
				'limit' => $elementsPerPage,
				'offset' => $offset));
		
	}
	public function findRecommendedEventsCategoryTime($filter_time, $filter_category, $offset, $elementsPerPage, $user_id){
	
		return $this->find('all', array (
				'conditions' => array($filter_category,$filter_time),
				'contain' => array ('City'),
				'limit' => $elementsPerPage,
				'offset' => $offset,
				'joins' => array(
					array(
			            'table' => 'user_events',
			            'alias' => 'UserEvent',
			            'type' => 'INNER',
			            'conditions' => array(
			                'Event.id = UserEvent.event_id', 'UserEvent.user_id' => $user_id, 'UserEvent.status_id' => Constants:: $USER_EVENT_RECOMMENDED, 'UserEvent.sr_score >' => 0
			            )
        		))
				
				));
	
	}
	public function findTopEventsCategoryTime($filter_time, $filter_category, $offset, $elementsPerPage){
	
		$count = $this->UserEvent->find ('all', array(
				'group' => 'UserEvent.event_id',
				'fields' => 'UserEvent.id_count, UserEvent.event_id',
				'limit' => 20,
				'conditions' => array ('UserEvent.status_id' => array(Constants::$USER_EVENT_GO, Constants::$USER_EVENT_MAYBE)) ,
				'order' => 'UserEvent.id_count DESC'));
		$events_id = array();
		foreach ($count as $count_event){
			array_push($events_id,$count_event['UserEvent']['event_id']);
		}
		return $this->find('all', array (
				'conditions' => array(
						$filter_category,
						$filter_time,
						'Event.id' => $events_id),
				'contain' => array ('City'),
				));
	
	}
	
	public function findRandomEventsCategoryTime ($filter_time, $filter_category, $offset, $elementsPerPage){

		return $this->find('all', array (
				'conditions' => array($filter_category,$filter_time),
				'contain' => array ('City'),
				'limit' => 20,
				'order' => 'rand()'));
	}
}

